package com.bzd.web.controller.xsgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.xsgl.SXsglXsmxSpmxSalesdetailinfoService;

import java.util.List;

/**
*
* 销售商品明细表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "xsgl/sxsglxsmxspmxsalesdetailinfo")
public class SXsglXsmxSpmxSalesdetailinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "xsgl";

    @Autowired
    private SXsglXsmxSpmxSalesdetailinfoService sXsglXsmxSpmxSalesdetailinfoService;

    /**
    * 销售商品明细表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxSpmxSalesdetailinfoAdd")
    public String add() {
        return prefix + "/SXsglXsmxSpmxSalesdetailinfoAdd";
    }

    /**
    * 销售商品明细表 新增
    *
    * @return
    */
    @Log(title = "销售商品明细表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sXsglXsmxSpmxSalesdetailinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sXsglXsmxSpmxSalesdetailinfoService.addSXsglXsmxSpmxSalesdetailinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 销售商品明细表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxSpmxSalesdetailinfoView")
    public String sxsglxsmxspmxsalesdetailinfoListView() {
        return prefix + "/SXsglXsmxSpmxSalesdetailinfoList";
    }

    /**
    * 销售商品明细表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:sXsglXsmxSpmxSalesdetailinfoList")
    @PostMapping("/sXsglXsmxSpmxSalesdetailinfoList")
    @ResponseBody
    public TableDataInfo sxsglxsmxspmxsalesdetailinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sXsglXsmxSpmxSalesdetailinfoService.findSXsglXsmxSpmxSalesdetailinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 销售商品明细表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:remove")
    @Log(title = "销售商品明细表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sXsglXsmxSpmxSalesdetailinfoRemove")
    @ResponseBody
    public AjaxResult sxsglxsmxspmxsalesdetailinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sXsglXsmxSpmxSalesdetailinfoService.SXsglXsmxSpmxSalesdetailinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 销售商品明细表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:edit")
    @GetMapping("/sXsglXsmxSpmxSalesdetailinfoEdit/{id}")
    public String sxsglxsmxspmxsalesdetailinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sXsglXsmxSpmxSalesdetailinfoService.findSXsglXsmxSpmxSalesdetailinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sxsglxsmxspmxsalesdetailinfoPageEdit";
        }
        return prefix+ "/sxsglxsmxspmxsalesdetailinfoEdit";
    }

    /**
    * 销售商品明细表保存修改的数据
    */
    @RequiresPermissions("xsgl:xs:edit")
    @Log(title = "销售商品明细表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sXsglXsmxSpmxSalesdetailinfoEdit")
    @ResponseBody
    public AjaxResult sxsglxsmxspmxsalesdetailinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sXsglXsmxSpmxSalesdetailinfoService.updateSXsglXsmxSpmxSalesdetailinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sxsglxsmxspmxsalesdetailinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sxsglxsmxspmxsalesdetailinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
